<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 

if ( ! class_exists('Model'))
{            
    require_once(BASEPATH.'libraries/Model'.EXT);
}

/**
 * @name ACICRUD
 * @author Samuel Sanchez <samuel.sanchez.work@gmail.com> - http://www.kromack.com/acicrud/
 * @package CodeIgniter
 * @copyright ACICRUD by Samuel Sanchez is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License. Permissions beyond the scope of this license may be available at http://www.kromack.com/.
 * @license http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 * @tutorial http://www.kromack.com/acicrud/
 * @see http://www.kromack.com/acicrud/
 * 
 */
class Acicrud extends Model {

    //DATABASE PROPERTIES
   
        //Table name
        protected $table = '';
		
		//Version
		private static $version = '86ef21a05a4c9697ae01fb9b17736ef24704cbf8';
       
    //ATTRIBUTES
       
        //Leave empty or set it to override the constructor routine. Your table must be at least 1NF.
        public $key = '';
       
        //Leave empty or set it to override the constructor function
        public $fields = array();
        
        //Useful to call another model inside a model via $this->CI
       	public $CI = NULL;   
       	
        //Last inserted ID by Acicrud
        public $last_id = FALSE;       	    
     
   
    //CONSTRUCTOR   
   
	/**
	* PHP5 constructor.
	* 
	* Not directly used for legacy compatibility.
	*
	* @param string $table
	*/
    public function __construct($table = null) {
    	
    	if(!is_null($table)) {
    		$this->Acicrud($table);
    	}	
    }

	/**
	* Original PHP4 constructor. 
	*
	* @param string $table
	* @return Acicrud
	*/
    public function Acicrud($table = null)
    {
        parent::Model();
        
        if(!is_null($table)) {
        	
	        $this->table = $table;
	       
	        //Setting the array of SQL fields
	        $fields = $this->db->list_fields($this->table);
	       
	        //If $this->fields isn't overrided by the user
	        if(count($this->fields) == 0) {
	        	
	            foreach($fields as $row)
		        {
		            $this->fields[$row] = null;       
		        }        	
	        }
	                   
	        //Checking for the primary key
	        $fields = $this->db->field_data($this->table);
	               
	        //TODO: Add support for multi-dimensionnal primary keys
	        foreach ($fields as $row)
	        {
	            if($row->primary_key)
	            {
	                $this->key = $row->name;
	            }
	        } 
	        
	        $this->CI = & get_instance();
		}    
    }
   
    //CRUD
   
	/**
	* Load a database row as an object
	*
	* @param string $id
	*/
    public function load($id)
    {
        $this->db->select('*')->from($this->table)->where($this->key, $id);
        $query = $this->db->get();
 
        if($query->num_rows() == 0)
            throw new Exception('ID_' . $this->table . '_ERROR');
       
        $result = $query->row_array();
       
        foreach($result as $k => $v)
        {
            $this->fields[$k] = $v;
        }
    }
   
	/**
	* Read a database row and return an object
	*
	* @param string $id
	* @return object
	*/
    public function read($id)
    {
        try {
           
            $this->checkId($id);
           
            $this->load($id);
           
            foreach($this->fields as $k => $v)
            {
                $o->$k = $v;
            }       
               
            return $o;
        }
        catch(Exception $e)
        {
            throw $e;
        }
       
    }
    
	/**
	* Try to read the latest entry in the table.
	*
	* @return object
	*/
    public function readLast() {
    	
    	if($this->getMaxId() == 0) {

    		 throw new Exception($this->table . '_IS_EMPTY');
    		
    	} else {

    		return $this->read($this->getMaxId());    		
    	}
    }     
   
	/**
	* Check if a specific primary key value exist in database
	*
	* @param unknown_type $id
	*/
    public function checkId($id)
    {
        //TODO: May be add support to arrays ?
        if(is_array($id))
        {
            throw new Exception('CHECK_ID_' . $this->table . '_FAILLURE_BECAUSE_ID_IS_AN_ARRAY');
        }
               
        $this->db->where($this->key, $id);
		$this->db->from($this->table);
		$nb = $this->db->count_all_results();
				
        if($nb != 1)
        {
            throw new Exception('CHECK_ID_' . $this->table . '_FAILLURE');
        } else {
        	return TRUE;	
        }
    }
   
	/**
	* Insert a row in the database
	*
	* @param object $o
	*/
    public function create($o)
    {
        foreach($this->fields as $k => $v)
        {
            if(isset($o->$k)) // Prevent emptys id's
            {
                $this->db->set($k, $o->$k);    
            }
        }       
       
        if($this->db->insert($this->table) === TRUE) {
        	
        	$this->last_id = $this->insertId();
        	return $this->last_id;
        	
        } else {

            if(!$this->db->affected_rows() == 1)
	        {
	            throw new Exception('CREATE_' . $this->table . '_ERROR');
	        }        	
        }
   
    }   
   
	/**
	 * Delete rows.
	 * 
	 * Legacy compatibility : $where could be the numeric id of the row to delete.
	 * 
	 * @param array $where An associative array of field => value to use in the WHERE clause
	 * @return int
	 */ 
    public function delete($where)
    {	
    	try {
    		
    		if(is_numeric($where)) { 
    		
    			//Legacy compatibility
    			 $this->db->delete($this->table, array($this->key => $where));
    			
    		} else if (is_array($where)) {
    			
    			 $this->db->delete($this->table,$where);
    			
    		}

    	} catch(Exception $e) {
    		
    		throw new Exception('DELETE_' . $this->table . '_ERROR');
    		
    	}  		 		
    }
   
	/**
	* Update a specific row in the database by copying the local object
	*
	* @param object $o
	*/
    public function update($o)
    {       
    	foreach($o as $k => $v) {	
    		
    		//Checks if the field given by $o exist
    		if(array_key_exists($k, $this->fields)) {
    			$this->db->set($k, $o->$k);    
    		} 			
    	}  
        
        //Allow to call update() after read() without storing the $this->key value.
        if(!isset($o->{$this->key})) {
    		$o->{$this->key} = $this->fields[$this->key];
    	}        
       
        $this->db->where($this->key, $o->{$this->key});   
       
        $this->db->update($this->table) or die($this->db->last_query());
       
    }
   
   
	/**
	* Basic getter, return the $what value of the current object.
	*
	* @param string $what
	* @return string
	*/   
    public function getter($what) {
    	
    	return $this->fields[$what];     	
    	
    }  
   
	/**
	* Get the $what field value identified by the orilary key $id value
	*
	* @param string $what
	* @param string $id
	* @return mixed
	*/
    public function get($what, $id)
    {   
        //Get all $what
        if(is_null($id))
        {
            $this->db->select($what)->from($this->table);
            $query = $this->db->get();       
            return $query->result();
        }   
        else {
           
            //Get the specified $what for the specified $id
            try {
                $this->read($id);
                return $this->fields[$what];
            }
            catch(Exception $e)
            {
                die($e->getMessage());
            }   
        }
    }
    
    //CORE METHODS
	
	
	/**
	* Run the Active Record Query an return an array of objects
	*
	* @return array
	*/
    public function result() {
        $query = $this->db->get();       
        return $query->result();
    }
    
	/**
	* Run the Active Record Query an return one result object
	*
	* @return object
	*/
    public function row() {
        $query = $this->db->get();       
        return $query->row();
    } 
    
	/**
	* toString magic method
	*
	* @return string
	*/
    function __toString()
    {
    	$str = 'ACICRUD said :' . '<br /><br />Table : ' . $this->table . '<br />Key : ' . $this->key . '<br /><br /><pre>';
    	
    	ob_start();
    	
        echo var_dump($this->fields);
		
        $str .= ob_get_contents();
        
		ob_end_clean();
		
		$str .= '</pre>';
        
    	return $str;
    }

	/**
	* Stop the script execution in displaying the last query done by the database class.
	* Breaking of execution script can be prevent by givin false to the second parameter.
	* 
	* @tutorial Replace $this->result() by $this->debug() in your custom method.
	* @param boolean $executeQuery
	* @param boolean $die
	*/
    public function debug($executeQuery = true, $die = true) {
    	
    	if($executeQuery) {
    		$this->result();
    	}    	
    	
    	if($die) {
    		die($this->db->last_query());
    	} else {
    		echo($this->db->last_query());
    	}   	
    }
      
    /**
     * Perform WHERE CLAUSE
     * Usage : array(field, value)
     * @param array $where
     * @return void
     */
    protected function _where($where) {
    			
		foreach($where as $k=>$v) {
			$this->db->where($k, $v);		
		}
    }        
    
    /**
     * Perform the LIMIT SQL
     * 
     * if $limit is array, produces LIMIT $limit[1], 1$limit[0]
     * if $limit is int, produces LIMIT $limit
     * 
     * @param mixed $limit
     */
    protected function _limit($limit) {
    	
    	if(is_array($limit)) {
    		$this->db->limit($limit[1], $limit[0]);
    	} else {
    		$this->db->limit($limit);
    	}	
    }
    
    /**
     * Perform the ORDER BY SQL
     * 
     * Produces n times ORDER BY key => way
     * way MUST be 'DESC' or 'ASC'
     *
     * @param array $order
     */
    protected function _order_by($order) {
    	
		/** Legacy Compatibility **/

		if(!is_null($order)) {

			if(!is_array($order)) {			

				$way = $order;
				unset($order);
				$order = array($this->key => $way);
				
			} elseif((isset($order[0])) && (isset($order[1]))) {

				$key = $order[0];
				$way = $order[1];
				
				$order = array($key => $way);
			}
		}
		
		/** END Legacy Compatibility **/
		
		foreach($order as $k=>$v) {
			$this->db->order_by($k, $v);		
		}
    }  
   
    //COMMON METHODS 
	
	/**
	* Return a collection of $this->table rows. $limit can be used to LIMIT the query. 
	* $order can be used to ORDER BY results: $order[0] set the field and $order[1] set the way (ASC or DESC).
	*
	* @param mixed $limit
	* @param array $order
	* @return collection
	*/
	public function getAll($limit = null, $order = null, $where = null)

	{		
		$this->db->from($this->table);
		
		if(!is_null($limit)) {
			
			$this->_limit($limit);
		} 
		
		if(!is_null($order)) {

			$this->_order_by($order);              
		}	 
		
		//FIXME: $where devrait être le premier paramètre de la fonction getAll
		if(!is_null($where)) {
			
			$this->_where($where);
		} 				
		
		return $this->result();  
		
	}
    
    
	/**
	* Return the number of rows of the table
	*
	* @return integer
	*/    
    public function countAll($where = null)   
    {
        return $this->db->count_all($this->table);
    }    
    
    /**
     * Return the last inserted ID by Acicrud or by the DBMS if the first one doesn't exist.
     * @return integer
     */
    public function lastId() {
    	
     	if($this->last_id !== FALSE) {
    		
    		//It's more safe to return the last_id retrivied by $this->create() if it's exists.
    		return $this->last_id;
    		
    	} else {
    		
    		//Else we're returning the last inserted id given by the DBMS
    		return $this->db->insert_id();
    	}     	
    }
     
    /**
	* This method is an alias of $this->lastId keeped for legacy compatibility.
	* @return integer
	*/
    public function insertId() {
    	return $this->lastId();
    }  
     
    /**
     * Returns the largest currently used ID in the table or 0 if the table is empty.
     * 
     * @return integer
     */
    public function getMaxId() {
    	
		$this->db->select_max($this->key);
				
		$query = $this->db->get($this->table);
		
		$result = $query->row();
			
		$max_id  = $result->{$this->key};
			
		//Returns 0 instead of NULL if the table is empty.
		return((is_null($max_id)) ? 0 : $max_id);
    	
    }     
     
    /**
    *
    * /!\ DOT NOT USE THIS METHOD ANYMORE /!\
    *
    * This method will be removed soon
    *  
	* Return a french formated datetime as 19-01-2009
	* 
	* @param string $field
	* @param integer $id
	* @return unknown
	*/
    public function getFrenchDate($field, $id) {
    	$this->db->select("DATE_FORMAT($field, '%d-%m-%Y') AS $field", FALSE)->from($this->table)->where($this->key, $id);
    	$result = $this->row();
    	return $result->{$field};
    }
}

?>